unit tspeaker;

{

This is PC Speaker access component. Setting the frequency property to 0 or
negative value will swith the speaker off. When it is set to positive value,
speaker starts to beep continuously with this frequency.

Komponent do obslugi glosniczka. Ustawienie wlasciwosci frequency rozpoczyna
generowanie dzwieku o takiej czestotliwosci. Ustawienie na zero lub liczbe
ujemna wylacza glosniczek.

FREEWARE by Luke Komsta luke@ariadna.pl

}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TSpeaker = class(TComponent)
  private
           freq : word;
  procedure setfreq(value : word);
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
  property Frequency : word read freq write setfreq;
  end;

procedure Register;

implementation

procedure tspeaker.setfreq(value : word);
var frq : word;
begin
     freq:=value;
     if freq>0 then begin
     frq:=1200000 div freq;
                    asm
                    mov cx,frq
                    in al,61h
                    test al,03
                    jnz @1
                    or al,03
                    out 61h,al
                    mov al,0b6h
                    out 43h,al
                    @1: mov al,cl
                    out 42h,al
                    mov al,ch
                    out 42h,al
                    end
                    end
     else begin
          asm
             in al,61h
                and al,0fch
                   out 61h,al
                   end;
          end;

end;

procedure Register;
begin
  RegisterComponents('Samples', [TSpeaker]);
end;

end.
